=== debian/changelog ===
coq-doc (8.18.0-1) unstable; urgency=medium

  * Make sure the html documentation uses local mathjax (Closes: #1056948).
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 25 Jan 2024 13:58:36 +0100
