=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:

override_dh_auto_build:
	$(MAKE) dunestrap
	SPHINXWARNOPT=-q dune build @refman-html @refman-pdf --display=verbose
	find _build/ -type f -name "*.html" | \
		xargs sed -i -e "s|https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js|file:///usr/share/nodejs/mathjax-full/es5/tex-mml-chtml.js|g"

override_dh_auto_test:

override_dh_auto_install:
