## coq-doc 8.19.1

=== debian/changelog ===
coq-doc (8.19.1-2) unstable; urgency=medium

  * Call "dune build" with --release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 18 Jun 2024 11:16:07 +0200

coq-doc (8.19.1-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 15 Apr 2024 09:08:18 +0200
