=== debian/changelog ===
coq-doc (8.20.0-2) UNRELEASED; urgency=medium

  * Add patch to compile with recent Python versions
    (Closes: #1093324, #1093100).

 -- Julien Puydt <jpuydt@debian.org>  Mon, 20 Jan 2025 12:58:56 +0100

coq-doc (8.20.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards-version to 4.7.0.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 26 Dec 2024 21:46:53 +0100
