=== debian/watch ===
version=4
https://github.com/coq/coq/tags .*/[vV]?(\d[^\s+]+)\.tar\.gz
